Summary: Manipulate system time per process for testing purposes
Name: libfaketime
Version: 0.9.10
Release:    2%{?dist}
License: GPL-2.0-or-later AND GPL-3.0-only
Url: https://github.com/wolfcw/libfaketime
Source0: https://github.com/wolfcw/libfaketime/archive/v%{version}/%{name}-%{version}.tar.gz

Patch0: libfaketime-backports.patch
Patch1: libfaketime-symver.patch
Patch2: 0001-Disable-unused-result-warning-in-tests.patch

Provides: faketime = %{version}

BuildRequires:  gcc
BuildRequires:  perl-interpreter
BuildRequires:  perl-Time-HiRes
BuildRequires: make
Excludearch: %{ix86} %{arm}

%description
libfaketime intercepts various system calls which programs use to
retrieve the current date and time. It can then report faked dates and
times (as specified by you, the user) to these programs. This means you
can modify the system time a program sees without having to change the
time system- wide.

%prep
%autosetup -p1

%build

cd src


FAKETIME_COMPILE_CFLAGS="BOGUS"
  %ifarch x86_64
    echo "force_monotonic"
    export FAKETIME_COMPILE_CFLAGS="-DFORCE_MONOTONIC_FIX"
  %endif
  %ifarch riscv64
    echo "force_monotonic and pthread_nonver"
    export FAKETIME_COMPILE_CFLAGS="-DFORCE_MONOTONIC_FIX -DFORCE_PTHREAD_NONVER"
  %endif
  %ifarch aarch64
    unset FAKETIME_COMPILE_CFLAGS
  %endif

if [ "$FAKETIME_COMPILE_CFLAGS" == "BOGUS" ]; then
  echo "SHOULD NEVER REACH HERE ... YOU HAVE AN UNTESTED VERSION+ARCH, see rpm spec for details ... ABORT"
  exit 1
fi

CFLAGS="%{optflags} -Wno-nonnull-compare -Wno-strict-aliasing" make %{?_smp_mflags} \
         PREFIX="%{_prefix}" LIBDIRNAME="/%{_lib}/faketime" all

%check
make %{?_smp_mflags} -C test

%install
make PREFIX="%{_prefix}" DESTDIR=%{buildroot} LIBDIRNAME="/%{_lib}/faketime" install
rm -r %{buildroot}/%{_docdir}/faketime
chmod a+rx %{buildroot}/%{_libdir}/faketime/*.so.*


%files
%{_bindir}/faketime
%dir %attr(0755, root, root) %{_libdir}/faketime/
%attr(0755, root, root) %{_libdir}/faketime/libfaketime*so.*
%license COPYING
%doc README NEWS README.developers
%{_mandir}/man1/*

%changelog
* Tue May 07 2024 Fanjun Kong <fanjunkong@tencent.com> - 0.9.10-2
- epol debrand

* Mon Apr 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.10-1
- initial build
